' ---------------------------------------------------------------------------
' fishingModel.vbs
' Created on: Sun Mar 07 2010 10:08:14 PM
'   (generated by ArcGIS/ModelBuilder)
' Usage: fishingModel <basemap> <contours> <depth_ASC> <Output_cell_size> 
' ---------------------------------------------------------------------------

' Create the Geoprocessor object
set gp = WScript.CreateObject("esriGeoprocessing.GPDispatch.1")

' Check out any necessary licenses
gp.CheckOutExtension "spatial"

' Load required toolboxes...
gp.AddToolbox "C:/Program Files (x86)/ArcGIS/ArcToolbox/Toolboxes/Spatial Analyst Tools.tbx"
gp.AddToolbox "C:/Program Files (x86)/ArcGIS/ArcToolbox/Toolboxes/Conversion Tools.tbx"

' Set the Geoprocessing environment...
gp.scratchWorkspace = "C:\temp"

' Script arguments...
basemap = wscript.arguments.item(0)
if basemap = "#" then
 basemap = "basemap" ' provide a default value if unspecified
end if

contours = wscript.arguments.item(1)
if contours = "#" then
 contours = "contours" ' provide a default value if unspecified
end if

depth_ASC = wscript.arguments.item(2)
if depth_ASC = "#" then
 depth_ASC = "C:\dev\svngisci\StrategicFishingSystem\Wisconsin lakes\utm16\Big Bay de Noc\depth.ASC" ' provide a default value if unspecified
end if

Output_cell_size = wscript.arguments.item(3)
if Output_cell_size = "#" then
 Output_cell_size = "6" ' provide a default value if unspecified
end if

' Local variables...
TopoToR_cont1 = "C:\temp\TopoToR_cont1"
Output_stream_polyline_features = ""
Output_remaining_sink_point_features = ""
Output_diagnostic_file = ""
topoToRaster_parameters_TXT = ""
clip_depth = "C:\temp\Extract_Topo1"
Filterdepth1 = "C:\temp\Filter_Extra1"
filterdepth2 = "C:\temp\Filter_Filte1"
result_depth1 = "C:\temp\Extract_Filt1"
SingleOutput1 = "C:\temp\SingleOutput1"

' Process: Topo to Raster...
gp.TopoToRaster_sa "contours DEPTH Contour", TopoToR_cont1, Output_cell_size, "506149.828269492 5056621.83435698 536625.816697263 5083311.08362553", "20", "", "", "NO_ENFORCE", "CONTOUR", "40", "0.2", "1.3", "0", "", "", Output_stream_polyline_features, Output_remaining_sink_point_features, Output_diagnostic_file, topoToRaster_parameters_TXT

' Process: Extract by Mask (2)...
gp.ExtractByMask_sa TopoToR_cont1, basemap, clip_depth

' Process: Filter...
gp.Filter_sa clip_depth, Filterdepth1, "LOW", "DATA"

' Process: Filter (2)...
gp.Filter_sa Filterdepth1, filterdepth2, "LOW", "DATA"

' Process: Extract by Mask...
gp.ExtractByMask_sa filterdepth2, basemap, result_depth1

' Process: Single Output Map Algebra (2)...
gp.SingleOutputMapAlgebra_sa "con(result_depth1 < 0, 0, result_depth1)", SingleOutput1, "C:\temp\Extract_Filt1"

' Process: Raster to ASCII...
gp.RasterToASCII_conversion SingleOutput1, depth_ASC

